import josx.platform.rcx.*;

public class Climber {

	/**
	 * @param args
	 *
	 */
	static Motor M_left = Motor.C;		// linker Motor
	static Motor M_right = Motor.A;		// rechter Motor
	
	static Sensor[] sensor = new Sensor[]{Sensor.S1,Sensor.S3};
//	static Sensor S_right = Sensor.S1;  //rechter Sensor
	static Sensor S_middle = Sensor.S2;	//Stostange
//	static Sensor S_left = Sensor.S3;	//linker Sensor
	
	static int[] white;					//eingelesene Farben beim justieren
	static int[] green;
	static int[] black;
	
	static int readValue;				//Temporrvariabe fr eigelesene Werte
	
	static int[] border;					//der Grenzwert ab dem fr den Robo schwarz ist.
	static boolean crashed; 			//gibt an ob der Robo gegen eine Wand gefahren ist.
	static boolean direction;
	
	//Optionen
	
	static int maxPower = 5;			//Maxpower auf Motoren
	
	static void sleep(int milis) {
		try {
			Thread.sleep(milis);

			}
			catch(Exception e){}
			}
	
	static void turn(boolean direction, int time){
		if (direction) {
			M_left.forward();
			M_right.backward();
		}
		else {
			M_left.backward();
			M_right.forward();
		}
		M_left.setPower(maxPower);
		M_right.setPower(maxPower);
		sleep(time);
		M_left.stop();
		M_right.stop();
	}

	static void justieren() {
		
		// Untergrund einlesen
		white = new int [2];
		green = new int [2];
		black = new int [2];
		border = new int [2];
		for (int i=0;i<2;i++){ 
			if (i==0) TextLCD.print("right");
			else TextLCD.print("left"); sleep(1000);
			TextLCD.print("side"); sleep(1000);
			TextLCD.print("read"); sleep(1000);
			TextLCD.print("press"); sleep(1000);
			TextLCD.print("VIEW"); sleep(1000);
			TextLCD.print("white");
			Sound.beep();
			while (!Button.VIEW.isPressed()) {
			}
			while (Button.VIEW.isPressed()) {
				white[i] = sensor[i].readRawValue();
				Sound.beep();
				LCD.showNumber(white[i]);sleep(1000);
			}
			TextLCD.print("green");
			while (!Button.VIEW.isPressed()) {
			}
			while (Button.VIEW.isPressed()) {
				green[i] = sensor[i].readRawValue();
				Sound.beep();
				LCD.showNumber(green[i]);sleep(1000);
			}
			TextLCD.print("black");
			while (!Button.VIEW.isPressed()) {
			}
			while (Button.VIEW.isPressed()) {
				black[i] = sensor[i].readRawValue();
				Sound.beep();
				LCD.showNumber(black[i]);sleep(1000);
			}
		
		// Grenze berechnen
			border[i] = (green[i] + black[i]) / 2;
		}
		TextLCD.print("Ready");
		Sound.beepSequence();
		sleep(1000);
	}
	
	static void floatMotor(Motor m){
		if(!m.isBackward()){
			m.setPower(1);
			m.backward();
		}
		else if (m.getPower() < maxPower){
			m.setPower(m.getPower()+1);
		}
	}
	
	static void powerMotor(Motor m){
		if(!m.isForward()){
			m.forward();
			m.setPower(1);
		}
		else if (m.getPower() < maxPower){
			m.setPower(m.getPower()+1);
		}
		
	}
	
	static boolean checkBlack(){
		readValue = sensor[1].readRawValue();
		if (readValue>border[1]) return true;
		readValue = sensor[0].readRawValue();
		if (readValue>border[0]) return true;
		return false;
	}
	
	static void laufen(){
		direction=false;
		int count=0;
		TextLCD.print("press"); sleep(1000);
		TextLCD.print("RUN");
		while (!Button.RUN.isPressed()) {
		}
		while (Button.RUN.isPressed()) {
		}
		sleep(1000);
		// erst wenn Run gedrckt wurde geht es los, das gibt zeit zur positionierung
		crashed = false;
		while (!(Button.RUN.isPressed()||crashed)) {
			crashed = S_middle.readBooleanValue();
			readValue = sensor[1].readRawValue();
			if (readValue<border[1]) {
				powerMotor(M_left);
				count++;
			}
			else {
				floatMotor(M_left);
				count=0;
			}
			readValue = sensor[0].readRawValue();
			if (readValue<border[0]) {
				powerMotor(M_right);
				count++;
			}
			else {
				floatMotor(M_right);
				count=0;
			}
			if (count>100) {
				count=5;
				while (count > 0) {
					turn(direction, 100);
					if (checkBlack())
						count=0;
					count--;
					}
				if (count==0)count=10;
				direction = !direction;
				while (count > 0) {
					turn(direction, 100);
					if (checkBlack())
						count=0;
					count--;
					}
				direction = !direction;
				if (count==0)count=5;
				while (count > 0) {
					turn(direction, 100);
					if (checkBlack())
						count=0;
					count--;
					}
				count=0;
			}
			sleep(20);
		}
		
	}
	
	
	public static void main(String[] args) {
		//initierung in der main
		Sensor.S1.activate();
		Sensor.S2.activate();
		Sensor.S3.activate();
		Serial.setRangeLong();
		sensor[0].setTypeAndMode(SensorConstants.SENSOR_TYPE_LIGHT,
				SensorConstants.SENSOR_MODE_PCT);
		S_middle.setTypeAndMode(SensorConstants.SENSOR_TYPE_TOUCH,
				SensorConstants.SENSOR_MODE_BOOL);
		sensor[1].setTypeAndMode(SensorConstants.SENSOR_TYPE_LIGHT,
				SensorConstants.SENSOR_MODE_PCT);
		M_right.stop();
		M_left.stop();
		
		//einlesen von farbwerten
		justieren();
		//hier rennt er los
		laufen();

	}

}
